/* Copyright 1990 by Giuseppe Zanetti */
/* telefono 049-638225 Padova (Italy) */

#define VIDEO_INT   0x10

#include <dos.h>
#include <stdio.h>

typedef struct
        {
                unsigned char red,green,blue;
        } vgapalette;

vgapalette       palette[256];

void make_palette()
{
        palette[0].red=       0;    /* black */
        palette[0].green=     0;
        palette[0].blue=      0;

        palette[1].red=       0;    /* blue */
        palette[1].green=     0;
        palette[1].blue=    255;

        palette[4].red=     255;    /* red */
        palette[4].green=     0;
        palette[4].blue=      0;

        palette[3].red=     255;    /* magenta */
        palette[3].green=     0;
        palette[3].blue=    255;

        palette[2].red=       0;    /* green */
        palette[2].green=   255;
        palette[2].blue=      0;

        palette[5].red=       0;    /* cyan */
        palette[5].green=   255;
        palette[5].blue=    255;

        palette[14].red=     255;    /* yellow */
        palette[14].green=   255;
        palette[14].blue=      0;

        palette[15].red=     255;    /* white */
        palette[15].green=   255;
        palette[15].blue=    255;
}

int get_vga_dot(x,y)
int x,y;
{
    union REGS in, out;

    in.h.ah =0xd;
    in.x.dx =y;
    in.x.cx =x;
    in.h.bh =0;
    int86(VIDEO_INT, &in, &out);

    return(out.h.al);
}

void gifsave(fn)
char *fn;
{
    sound(220);
    delay(500);
    sound(300);
    delay(200);
    nosound();

    GIFEncode (fn,512,256,0,0,8,palette,get_vga_dot);

    sound(300);
    delay(200);
    nosound();
}


main(argc,argv)
int     argc;
char	*argv[];
{
    int i;
    char fn[255];

	if (argc==1)
    {
        fprintf(stderr,"usage: %s filename\n",argv[0]);
        fprintf(stderr,"\nby Giuseppe Zanetti tel. 049-638225 Abano Terme, Padova (Italy)\n\n");
        fprintf(stderr,"This program is SHAREWARE. My E-mail: beppe@sabrina.dei.unipd.it\n\n");
        exit (1);
    }

    strcpy(fn,argv[1]);

    make_palette();
    gifsave(fn);

	return(0);
}


