/* lettore di schermate del QL        */
/* Copyright 1990 by Giuseppe Zanetti */
/* telefono 049-638225 Padova (Italy) */

#include <stdio.h>
#include "vga.c"

#define     VERSIONE    "QLSCR VERSION 4.10 \n=============\n\n"


main(argc,argv)
int	argc;
char	*argv[];
{
	FILE	*ql;
	int	x,y,b;
	unsigned char	h,l,c;
    int mode,vga,lines,i,gray,nostop,ql2gif;
    char cmd[255];

	int color[]={0,1,4,3,2,5,14,15};


	if (argc==1)
		{ fprintf(stderr,VERSIONE);
		  fprintf(stderr,"QL scr reader: use %s file [switches]\n",argv[0]);
		  fprintf(stderr,"\nQL screen reader by Giuseppe Zanetti tel. 049-638225 Abano Terme, Padova (Italy)\n\n");
		  fprintf(stderr,"-4 ... use 4 colors mode\n-8 ... use 8 colors mode\n-d .. use double size 8 colors mode\n");
		  fprintf(stderr,"\n\n-h .. VGA 640x480\n-l .. VGA 320x200\n-p .. VGA PARADISE ONLY (use carefully !)\n-g .. Use grays\n\n");
          fprintf(stderr,"-q .. do not restore text mode\n-s ..exec ql2gif\n\n");
          fprintf(stderr,"This program is SHAREWARE. My E-mail: beppe@sabrina.dei.unipd.it\n\n");
		  exit (1);
		}

    vga=0;
    mode=4;
	gray=0;
    nostop=0;
    ql2gif=0;

	for(i=1;i<argc;i++)
	{
		if ((argv[i][0]=='-') || (argv[i][0]=='/'))
		{
			switch(argv[i][1])
			{
				case '8': mode=8; break;
				case '4': mode=4; break;
				case 'd': mode=16; break;
				case 'g': gray=1; break;
				case 'l': vga=1; break;
				case 'h': vga=0; break;
				case 'p': vga=2; break;
                case 'q': nostop=1; break;
                case 's':ql2gif=1; break;
				default: fprintf(stderr,"Bad parameters. Use %s for help\n\n",argv[0]); exit(-1); break;
			}
		}
	}


	ql=fopen (argv[1],"rb");

	if (ql == NULL)
		{ fprintf(stderr,"QL scr reader: not valid file\n");
		  exit (-1);
		}

	switch(vga)
	{
		case 1:
				lines=200;
				vga_mode(VGA320200);
				break;
		case 0:
				lines=256;
				vga_mode(VGA640480);
				break;
		case 2:
                lines=256;
				vga_mode(VGA640400);
				break;
	}


	if (mode==4)
	{ for (y=0;(y<lines) && (!(feof(ql)));y++)
		for (x=0;x<64;x++)
			{ h=fgetc(ql);
			  l=fgetc(ql);
			  	for (b=7;b>=0;b--)
					{ c = (h & 0x01)*2 + (l & 0x01);
					  vga_dot (x*8+b,y,color[c*2+1*(c==3)]);
					  h>>=1;
					  l>>=1;
					}
			}
	}

	if (mode!=4)
	{ for (y=0;(y<lines) && (!(feof(ql)));y++)
		for (x=0;x<64;x++)
			{ h=fgetc(ql);
			  l=fgetc(ql);
			  	for (b=3;b>=0;b--)
					{ c = (h & 0x01)*0 + (l & 0x01);
					  h>>=1;
					  l>>=1;
					  c = c + (h & 0x01)*4 + (l & 0x01)*2;
					  if (mode==8)
						vga_dot (x*4+b,y,color[c]);
					  else 	{ vga_dot ((x*4+b)*2,y,color[c]);
						  vga_dot ((x*4+b)*2+1,y,color[c]);
						}
					  h>>=1;
					  l>>=1;
					}
			}
	}


	if (gray)
	{
		for (i=0;i<8;i++)
		{
            c=(63*i)/7;
			set_vga_pal (color[i],c,c,c);
		}
	}

	fclose (ql);

    if (ql2gif)
    {
        strcpy(cmd,"ql2gif.exe ");
        strcat(cmd,argv[1]);

        if (strchr(argv[1],'.') == NULL)
        {
            strcat(cmd,".gif");
        }
        else
        {
            strcpy(strrchr(cmd,'.'),".gif");
        }

        system(cmd);
    }

    if (nostop == 0)
    {
        getch();
        text_mode();
    }

	return(0);
}
